/**********************************************************************/
/*                                                                    */
/*                                                                    */
/*    Programme gestion USB                                           */
/*                                                                    */
/*     VERSION VERY SMALL                                             */
/*@                                                                   */
/**********************************************************************/
/* journal

fichier INF: ezusbw2k.inf
driver ezusb.sys


Fin du journal */


#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <winioctl.h>
#include <fcntl.h>              //option ouverture fichier
#include "ezusbsys.h"

#include "PGX01_5usb.h"



/***********************************************************************/
/*                                                                    */
/*                                                                    */
/*@                Prototypes                                          */
/**********************************************************************/
// Selection CPU
#define CPUCS_REG_EZUSB    0x7F92
#define CPUCS_REG_FX2      0xE600

#define CPU_Target CPUCS_REG_FX2



//******************************

#define ReadLen     16
#define WriteLen    16
#define PackOk 0
#define erreur -1

#define USBFile "\\\\.\\ezusb-0"

/////message de debug  
//#define NOISY(_x_) printf _x_ ;
#define  NOISY(_x_) ;


//HANDLE hRead = INVALID_HANDLE_VALUE, hWrite = INVALID_HANDLE_VALUE;


/**********************************************************************/
/*                                                                    */
/*                                                                    */
/*@               Affichage des erreurs                               */
/**********************************************************************/

//affichage numero de l'erreur
void Perror()
{int er;er=GetLastError();NOISY((" Erreur: %d \n",er))
if (er==2)NOISY(("The system cannot find the file specified. \n",er))
if (er==996)NOISY(("Overlapped I/O event is not in a signaled state.\n",er))
if (er==997)NOISY(("Overlapped I/O operation is in progress.\n",er)) 
}

/***********************************************************************/
/*                                                                     */
/*                                                                    */
/*@               Gestion par DEVICEIOCONTROL                         */
/**********************************************************************/



///////////////////////////////////////////////////////////
//
// control structure for bulk and interrupt data transfers
//
///////////////////////////////////////////////////////////
//typedef struct _BULK_TRANSFER_CONTROL
//{
//   ULONG pipeNum; 
  
//} BULK_TRANSFER_CONTROL, *PBULK_TRANSFER_CONTROL;
// pipe number: 0...n, ordre de declaration du boitier.


/**********************************************************************/
/*                                                                    */
/*                                                                    */
/*@                                                                   */
/**********************************************************************/
//
static struct 
        {       char DeviceUSB[20];
                HANDLE handle;
                UCHAR DDRB;     	//valeur DDRB
                UCHAR PORTB; 		//valeur portB
                USHORT Reponse;
         } PGXObjet;




/**********************************************************************/
/*                                                                    */
/*                                                                    */
/*@                                                                   */
/**********************************************************************/
//declaration numero endpoint
BULK_TRANSFER_CONTROL bulkControl;


/**********************************************************************/
/*                                                                    */
/*                                                                    */
/*@                                                                   */
/**********************************************************************/



/**********************************************************************/
/*                                                                    */
/*                                                                    */
/*@                                                                   */
/**********************************************************************/



//ouverture device
int IOPack_openH(char Message)
{
int success=1;
HANDLE Filehandle;

        ULONG FFILE_FLAG_OVERLAPPED;
        FFILE_FLAG_OVERLAPPED=0;                //non over
        
        
        //PGXObjet.DeviceUSB= "\\\\.\\ezusb-0";
        
        Filehandle= CreateFile("\\\\.\\ezusb-0",
        GENERIC_WRITE | GENERIC_READ,
        FILE_SHARE_WRITE | FILE_SHARE_READ,
        NULL,
        OPEN_EXISTING,
        FFILE_FLAG_OVERLAPPED,
        NULL);

  PGXObjet.handle=Filehandle;
    if (PGXObjet.handle == INVALID_HANDLE_VALUE) 
    		 {success=0; if (Message) {printf("Erreur ouverture device \n");Perror();}; }     
     	else    if (Message) printf("Ouverture Device OK.\n");
    
   
    return (success);
}


/////////// Fermeture
void IOPack_CloseH()
{// close devices if needed
        if(PGXObjet.handle != INVALID_HANDLE_VALUE)
        CloseHandle(PGXObjet.handle);       
}


/**********************************************************************/
/*                                                                    */
/*                                                                    */
/*@                                                                   */
/**********************************************************************/

//gestion portb
int  PGXPortB(UCHAR PORTDDRB, UCHAR ValXB)
        { 
        HANDLE handle = NULL;
        BOOLEAN success;
        ULONG nBytes;
        VENDOR_REQUEST_IN       myRequest;                      //
        WPARAM wParam;

        if (success= IOPack_openH(0))   //ouvrir
          {   handle = PGXObjet.handle;     
        if(PORTDDRB==0) myRequest.bRequest = 0x5; //PORTB data
         else myRequest.bRequest = 0x3; 		//PORTB DDRB    
              myRequest.wValue = ValXB;               
              myRequest.wIndex = 0x00;
              myRequest.wLength = 0x01;
              myRequest.bData = 0 ;                                   
              myRequest.direction = 0x01;	//direction 1 device to host                                                       
                
              success = DeviceIoControl (handle,
                        IOCTL_Ezusb_VENDOR_REQUEST,
                        &myRequest,
                        sizeof(VENDOR_REQUEST_IN),
                        NULL,
                        0,
                       (unsigned long *)&nBytes,
                        NULL);
                        
                        IOPack_CloseH();       //fermeture
                        
                        if (success == TRUE) 
                        {NOISY(" Reussi\n");
                        success = TRUE;}
                        else 
                        {NOISY("Echec  \n"); 
                        success = FALSE;}
                }
                else  return(FALSE);    
        
         return (success);
         }

//gestion commande prog PIC avec ou sans reponse
// n'ouvre ni ne ferme le pipe

int  PGXPICComd(UCHAR PICCommande,int PICDATA, int *Freponse)
        { 
        HANDLE handle ;
        BOOLEAN success;
        ULONG nBytes;
        VENDOR_REQUEST_IN       myRequest;                      //
        WPARAM wParam;
	   USHORT Reponse=0xAA55; 		// reponse	
        
        handle = PGXObjet.handle;     
        
        	PICDATA= ((PICDATA>>8)&0xFF) | ((PICDATA<<8)&0xFF00);
		PICDATA= (PICDATA<<1)&0xFFFF ;		//0 puis lsb en PIC 
		// printf("< %xh > ",PICDATA);
        myRequest.bRequest = 0x2; 								//commande  
        myRequest.wValue = (PICCommande&0xFF) | ((PICDATA<<8) &0xFF00) ; 	// low 1er            
        myRequest.wIndex = ((PICDATA>>8)&0xFF);						//high
        //printf("< %x %x > ",myRequest.wValue, myRequest.wIndex);
        myRequest.wLength = 0x02;
        myRequest.bData = 0 ;                                   
        myRequest.direction = 0x01;	//direction 1 device to host                                                       
                
              success = DeviceIoControl (handle,
                        IOCTL_Ezusb_VENDOR_REQUEST,
                        &myRequest,
                        sizeof(VENDOR_REQUEST_IN),
                        &Reponse,						//ex NULL
                        sizeof(USHORT),				//ex 0
                       (unsigned long *)&nBytes,
                        NULL); 
                        
            
           // Reponse = (((Reponse>>8)&0xFF) | ((Reponse<<8)&0xFF00)) ;
           //  Reponse = ((Reponse>>2)&0x7F00) | ((Reponse>>1)&0x00FF)  ;
            Reponse = ((Reponse>>1)&0x3FFF);
             *Freponse=Reponse;
            PGXObjet.Reponse =Reponse;
                        if (success == TRUE) 
                        {NOISY(" Reussi\n");
                        success = TRUE;}
                        else 
                        {NOISY("Echec  \n"); 
                        success = FALSE;}
                
        
         return (success);
         }





/**********************************************************************/
/*                                                                    */
/*                                                                    */
/*@                                                                   */
/**********************************************************************/


void PGXInit()
{
        PGXPortB(1, 0xF8);      //DDRB OUT sauf indata PB2 Data In, 
        PGXPortB(0, 0x80+ 0x3F);      //PORTB
	   PGXObjet.PORTB= 0x80+ 0x3F;	// DATA(OC)=1 CLK0 power_off(1) 
}


//configuration alim,clr
void PGXConf(UCHAR PConfig)
{
       switch (PConfig)
       {
       case PGXVCCON: PGXObjet.PORTB = PGXObjet.PORTB &~0x20;
       			  PGXPortB(0, PGXObjet.PORTB);break;
       case PGXVCCOFF:PGXObjet.PORTB = PGXObjet.PORTB | 0x20;
       			  PGXPortB(0, PGXObjet.PORTB);break;
       case PGXVPPON: PGXObjet.PORTB = PGXObjet.PORTB &~0x10;
	         		  PGXPortB(0, PGXObjet.PORTB);break;
	  case PGXVPPOFF:PGXObjet.PORTB = PGXObjet.PORTB | 0x10;
       			  PGXPortB(0, PGXObjet.PORTB);break;
       case PGXCLK0:  PGXObjet.PORTB = PGXObjet.PORTB &~0x40;
	  	         	  PGXPortB(0, PGXObjet.PORTB);break;
	  case PGXCLK1:  PGXObjet.PORTB = PGXObjet.PORTB | 0x40;
       			  PGXPortB(0, PGXObjet.PORTB);break;
       case PGXDAT0:  PGXObjet.PORTB = PGXObjet.PORTB &~0x80;
	  	  	       PGXPortB(0, PGXObjet.PORTB);break;
	  case PGXDAT1:  PGXObjet.PORTB = PGXObjet.PORTB | 0x80;
       			  PGXPortB(0, PGXObjet.PORTB);break;
       
       }

}



/**********************************************************************/
/*                                                                    */
/*                                                                    */
/*@                                                                   */
/**********************************************************************/
// comande PIC

//execute une commande 
void PGXComOne (UCHAR PCommande,int Data)
{	 BOOLEAN success;
	if (success= IOPack_openH(0))      //ouvrir
	{ PGXPICComd(PCommande,Data,&Data  );
	   IOPack_CloseH();       		//fermeture
	};

}

//PIC CLR PULSE
void PGXPICClrP()
	{ PGXConf(PGXVPPOFF);		//Vpp OFF
	 Att1s();
	  PGXConf(PGXVPPON);		//Vpp ON
	}


//mise en mode programmation
void PGXPICProg()
	{ PGXInit();  						//init
	  PGXConf(PGXDAT0);					//dat0
	  PGXConf(PGXCLK0);					//clk0
	  PGXConf(PGXVCCON);				//Vcc ON
	  	Att1s(); 
	  PGXConf(PGXVPPON);				//Vpp ON
	  PGXConf(PGXVPPON);				//Vpp ON
	  PGXConf(PGXVPPON);				//Vpp ON	  			  
	}

//power off
void PGXPICPwOff()
	{ PGXConf(PGXVCCOFF);				//Vcc OFF
	  PGXConf(PGXVPPOFF);				//Vpp OFF 
	}





//Test min
void PGXTstMin (UCHAR PCommande,int Data)
{	 BOOLEAN success;

	  PGXInit();  				//init 
	  PGXConf(PGXVCCON);		//Vcc ON
	  PGXConf(PGXVPPON);		//Vpp ON
	
	if (success= IOPack_openH(0))      //ouvrir
	{ 
	  PGXPICComd(PCommande,Data,&Data);
	  IOPack_CloseH();       		//fermeture
	}  
	
	  PGXConf(PGXVCCOFF);		//Vcc OFF
	  PGXConf(PGXVPPOFF);		//Vpp OFF
	
	
	   
};

void PICLect16F84()
{	 BOOLEAN success;
		int K,Data;
	  PGXInit();  						//init
	  PGXConf(PGXDAT0);					//dat0
	  PGXConf(PGXCLK0);					//clk0
	  PGXConf(PGXVCCON);				//Vcc ON
	  PGXConf(PGXVPPON);				//Vpp ON
	  PGXConf(PGXVPPON);				//Vpp ON
	  PGXConf(PGXVPPON);				//Vpp ON	  	
	if (success= IOPack_openH(0))      	//ouvrir
	{ 
		for (K=0; K<1024;K++)
		{PGXPICComd(PPICRdDataPM,0,&Data);		//read
		//printf ("%04x\n",PGXObjet.Reponse);
		 PGXPICComd(PPICIncAdres,0,&Data);		//increment
		}
	  
	  IOPack_CloseH();       			//fermeture
	}  	
	  PGXConf(PGXVCCOFF);				//Vcc OFF
	  PGXConf(PGXVPPOFF);				//Vpp OFF  
};



void PICLect16F841()
{	 BOOLEAN success;
		int K,Data;
	  PGXInit();  						//init
	  PGXConf(PGXDAT0);					//dat0
	  PGXConf(PGXCLK0);					//clk0
	  PGXConf(PGXVCCON);				//Vcc ON
	  PGXConf(PGXVPPON);				//Vpp ON
	  PGXConf(PGXVPPON);				//Vpp ON
	  PGXConf(PGXVPPON);				//Vpp ON	  	
	if (success= IOPack_openH(0))      	//ouvrir
	{ 
		for (K=0; K<16;K++)
		{PGXPICComd(PPICRdDataPM,0,&Data);		//read
		printf ("%04x\n",PGXObjet.Reponse);
		 PGXPICComd(PPICIncAdres,0,&Data);		//increment
		}
	  
	  IOPack_CloseH();       			//fermeture
	}  	
	  PGXConf(PGXVCCOFF);				//Vcc OFF
	  PGXConf(PGXVPPOFF);				//Vpp OFF  
};









/**********************************************************************/
/*                                                                    */
/*                                                                    */
/*@                                                                   */
/**********************************************************************/



